"""
Django settings for django project.

Generated by 'django-admin startproject' using Django 1.10.5.

For more information on this file, see
https://docs.djangoproject.com/en/1.10/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.10/ref/settings/
"""
import datetime
import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)

BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.10/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '((8&#%*_i+px5h18@4!wy&gdc3kcxjb9k9wgddl_nimaol@!#d'

# SECURITY WARNING: don't run with debug turned on in production!

ALLOWED_HOSTS = ['*', 'localhost', '127.0.0.1', '194.5.193.61']

KAVENEGAR_API_KEY = '5335696668626E75784D59365838474868543137754D31684B56617964467A67'
GHASEDAK_API_KEY = '6c7c464cebd2eaa94dd6723e8a5846cd8741f48518b8f43d53fbab5105d6a1e0'
# Application definition


IS_IN_PRODUCTION = True

if IS_IN_PRODUCTION is True:

    # DATABASE_NAME = os.environ['POSTGRES_DBNAME']
    # DATABASE_USER = os.environ['POSTGRES_USER']
    # DATABASE_PASSWORD = os.environ['POSTGRES_PASSWORD']
    # DATABASE_HOST = os.environ['POSTGRES_HOST']
    # DATABASE_PORT = os.environ['POSTGRES_PORT']
    # CELERY_BROKER_URL = os.environ['CELERY_BROKER_URL']

    DEBUG = False
    SEND_SMS = True
    CORS_ORIGIN_ALLOW_ALL = False
    DATABASES = {
        'default': {
            'ENGINE': 'django.contrib.gis.db.backends.postgis',
            'NAME': 'fekrino-db',
            'USER': 'postgres',
            'PASSWORD': 'pdnejoh',
            'HOST': 'postgres',
            'PORT': '5432'
        }
    }
    CHANNEL_LAYERS = {
        'default': {
            'BACKEND': 'channels_redis.core.RedisChannelLayer',
            'CONFIG': {
                "hosts": [('redis-channels', 6379)],
            },
        },
    }
    CELERY_BROKER_URL = 'redis://@redis-celery:6379'

else:
    DEBUG = True
    SEND_SMS = True
    CORS_ORIGIN_ALLOW_ALL = True
    DATABASES = {
        'default': {
            'ENGINE': 'django.contrib.gis.db.backends.postgis',
            'NAME': 'fekrino-db',
            'USER': 'mohsen',
            'PASSWORD': '123456789',
            'HOST': 'localhost',
            'PORT': '25432'
        }
    }
    CHANNEL_LAYERS = {
        'default': {
            'BACKEND': 'channels_redis.core.RedisChannelLayer',
            'CONFIG': {
                "hosts": [('127.0.0.1', 6379)],
            },
        },
    }
    CELERY_BROKER_URL = 'redis://@localhost:6379'


INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.gis',
    'rest_framework',
    'channels',
    'imagekit',
    'django_celery_beat',
    'profiles',
    'authentication',
    'match',
    'discover',
    'chat',
    # 'corsheaders', ######## IMPORTANT ##########
]

MIDDLEWARE = [
    # 'corsheaders.middleware.CorsMiddleware', ######## IMPORTANT ##########
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

CSRF_COOKIE_SECURE = False

ROOT_URLCONF = 'fekrino.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'fekrino.wsgi.application'

ASGI_APPLICATION = "fekrino.routing.application"


AUTH_USER_MODEL = 'profiles.User'

# Password validation
# https://docs.djangoproject.com/en/1.10/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': [
        'rest_framework.permissions.IsAuthenticated'
    ],
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_simplejwt.authentication.JWTAuthentication',
    ),
    'DEFAULT_THROTTLE_CLASSES': (
        'rest_framework.throttling.AnonRateThrottle',
        'rest_framework.throttling.UserRateThrottle'
    ),
    'DEFAULT_THROTTLE_RATES': {
        'anon': '60/minute',
        'user': '600/minute'
    },
}

SIMPLE_JWT = {
    'ACCESS_TOKEN_LIFETIME': datetime.timedelta(days=1),
    'REFRESH_TOKEN_LIFETIME': datetime.timedelta(days=30),
    'ROTATE_REFRESH_TOKENS': False,
    'BLACKLIST_AFTER_ROTATION': True,

    'ALGORITHM': 'HS256',
    'SIGNING_KEY': SECRET_KEY,
    'VERIFYING_KEY': None,
    'AUDIENCE': None,
    'ISSUER': None,

    'AUTH_HEADER_TYPES': ('JWT',),
    'USER_ID_FIELD': 'id',
    'USER_ID_CLAIM': 'user_id',

    'AUTH_TOKEN_CLASSES': ('rest_framework_simplejwt.tokens.AccessToken',),
    'TOKEN_TYPE_CLAIM': 'token_type',

    'JTI_CLAIM': 'jti',

    'SLIDING_TOKEN_REFRESH_EXP_CLAIM': 'refresh_exp',
    'SLIDING_TOKEN_LIFETIME': datetime.timedelta(days=1),
    'SLIDING_TOKEN_REFRESH_LIFETIME': datetime.timedelta(days=30),
}

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'verbose': {
            'format': '{levelname} {asctime} {module} {process:d} {thread:d} {message}',
            'style': '{',
        },
        'simple': {
            'format': '{levelname} {message}',
            'style': '{',
        },
    },
    'handlers': {
        'console': {
            'level': 'INFO',
            'class': 'logging.StreamHandler',
            'formatter': 'simple'
        },
        'debug-file': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': os.path.join(BASE_DIR, 'logs/debug.log'),
            'formatter': 'verbose',
            'maxBytes': 10485760,
            'backupCount': 20,
        },
        'error-file': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': os.path.join(BASE_DIR, 'logs/error.log'),
            # 'formatter': 'verbose',
            # 'maxBytes': 10485760,
            # 'backupCount': 20,
        },
        'critical-file': {
            'level': 'CRITICAL',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': os.path.join(BASE_DIR, 'logs/critical.log'),
            'formatter': 'verbose',
            'maxBytes': 10485760,
            'backupCount': 20,
        }
        # 'mail_admins': {
        #     'level': 'CRITICAL',
        #     'class': 'django.utils.log.AdminEmailHandler',
        #     'formatter': 'verbose',
        # }
    },
    'loggers': {
        'django': {
            'handlers': ['critical-file',  'error-file', 'debug-file', 'console'],
            'level': 'INFO',
            'propagate': True,
        },
        'authentication': {
            'handlers': ['critical-file',  'error-file', 'debug-file'],
            'level': 'INFO',
        },
        'discover': {
            'handlers': ['critical-file', 'error-file', 'debug-file'],
            'level': 'INFO',
        },
        'match': {
            'handlers': ['critical-file', 'error-file', 'debug-file'],
            'level': 'INFO',
        },
        'fekrino': {
            'handlers': ['critical-file', 'error-file', 'debug-file'],
            'level': 'INFO',
        },
        'profiles': {
            'handlers': ['critical-file', 'error-file', 'debug-file'],
            'level': 'INFO',
        }
    },
}

# Internationalization
# https://docs.djangoproject.com/en/1.10/topics/i18n/

LANGUAGE_CODE = 'en-us'

# TIME_ZONE = 'UTC'
TIME_ZONE = 'Asia/Tehran'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.10/howto/static-files/

STATIC_URL = '/static/'
MEDIA_URL = '/media/'

STATIC_ROOT = os.path.join(BASE_DIR, 'static')

MEDIA_ROOT = os.path.join(BASE_DIR, 'media')


##### Chat specific settings


CMD_TYPE_MESSAGE = 1
CMD_TYPE_STATUS = 2


COMMAND_TYPES_CHOICES = (
    (CMD_TYPE_MESSAGE, 'MESSAGE'),
    (CMD_TYPE_STATUS, 'STATUS'),
)

COMMAND_TYPES_LIST = [
    CMD_TYPE_MESSAGE,
    CMD_TYPE_STATUS,
]

#################################

MSG_TYPE_TEXT = 1
MSG_TYPE_IMAGE = 2
MSG_TYPE_VIDEO = 3
MSG_TYPE_STICKER = 4
MSG_TYPE_SYSTEM = 5

MESSAGE_TYPE_CHOICES = (
    (MSG_TYPE_TEXT, 'TEXT'),
    (MSG_TYPE_IMAGE, 'IMAGE'),
    (MSG_TYPE_VIDEO, 'VIDEO'),
    (MSG_TYPE_STICKER, 'STICKER'),
    (MSG_TYPE_SYSTEM, 'SYSTEM'),
)